
M = {}

local torqueConverter
local maxRPM

local roll
local pitch
local yaw

local defVals = {}
local fwheelsBroke = false

local function onReset(jbeamData)
    torqueConverter = powertrain.getDevice("torqueConverter")
    local hasTorqueConverter = torqueConverter and true
    if not torqueConverter then
        M.updateGFX = nil
    end

    maxRPM = powertrain.getDevice("mainEngine").maxRPM
    roll, pitch, yaw = 1

    defVals = {
        maxPitch = jbeamData.maxPitch or 10,
        speedScaling = jbeamData.speedScaling or 0.40,
        launchTorque = jbeamData.launchTorque or 19,
        weightreduce = jbeamData.weightreduce or false
    }

    fwheelsBroke = false
end

local function updateGFX(dt)
    local rpm = electrics.values.rpm
    local throttle = input.throttle
    local airspd = electrics.values.airspeed * 3.6
    roll, pitch, yaw = obj:getRollPitchYaw()

    if electrics.values.gearIndex > 0 and airspd > 100 then
        electrics.values.dragBrakes = electrics.values.brake
    else
        electrics.values.dragBrakes = 0
    end

    pitch = 1-(pitch*defVals.maxPitch)

    if pitch < 0 then
        pitch = 0
    end
    if pitch > 1 then
        pitch = 1
    end

    if not fwheelsBroke and defVals.weightreduce and airspd > 900 then
        beamstate.breakBreakGroup("wheel_FL")
        beamstate.breakBreakGroup("wheel_FR")
        fwheelsBroke = true
    end

    torqueConverter.stallTorqueRatio = 1 + (defVals.launchTorque*throttle) + (airspd > 50 and (airspd*(defVals.speedScaling*pitch)) or 0)
    -- obj.debugDrawProxy:drawText2D(float3(40,200,0), color(0,0,0,255), "Speed: " ..  string.format("%0.3f deg", pitch))
    -- obj.debugDrawProxy:drawText2D(float3(40,220,0), color(0,0,0,255), "STR: " ..  string.format("%0.3f :1", torqueConverter.stallTorqueRatio))
    -- obj.debugDrawProxy:drawText2D(float3(40,240,0), color(0,0,0,255), "Airspd: " ..  string.format("%0.3f km/h", (electrics.values.airspeed*3.6)))
end

M.init = onReset
M.onInit = onReset
M.onReset = onReset
M.updateGFX = updateGFX

return M